var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") return Reflect.decorate(decorators, target, key, desc);
    switch (arguments.length) {
        case 2: return decorators.reduceRight(function(o, d) { return (d && d(o)) || o; }, target);
        case 3: return decorators.reduceRight(function(o, d) { return (d && d(target, key)), void 0; }, void 0);
        case 4: return decorators.reduceRight(function(o, d) { return (d && d(target, key, o)) || o; }, desc);
    }
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var angular2_1 = require('angular2/angular2');
var dropdown_service_1 = require('./dropdown-service');
var Dropdown = (function () {
    function Dropdown(el) {
        this.el = el;
        this.onToggle = new angular2_1.EventEmitter();
        // todo: bind to route change event
    }
    Dropdown.prototype.onInit = function () {
        this.autoClose = this.autoClose || dropdown_service_1.ALWAYS;
        this.keyboardNav = typeof this.keyboardNav !== 'undefined';
        this.dropdownAppendToBody = typeof this.dropdownAppendToBody !== 'undefined';
        if (this.isOpen) {
        }
    };
    Dropdown.prototype.onDestroy = function () {
        if (this.dropdownAppendToBody && this.menuEl) {
            this.menuEl.nativeElement.remove();
        }
    };
    Object.defineProperty(Dropdown.prototype, "dropDownMenu", {
        set: function (dropdownMenu) {
            // init drop down menu
            this.menuEl = dropdownMenu.el;
            if (dropdownMenu.templateUrl) {
                this.dropdownMenuTemplateUrl = dropdownMenu.templateUrl;
            }
            if (this.dropdownAppendToBody) {
                window.document.body.appendChild(this.menuEl.nativeElement);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "dropDownToggle", {
        set: function (dropdownToggle) {
            // init toggle element
            this.toggleEl = dropdownToggle.el;
        },
        enumerable: true,
        configurable: true
    });
    Dropdown.prototype.toggle = function (open) {
        return this.isOpen = arguments.length ? !!open : !this.isOpen;
    };
    Object.defineProperty(Dropdown.prototype, "isOpen", {
        get: function () {
            return this._isOpen;
        },
        set: function (value) {
            this._isOpen = !!value;
            // todo: implement after porting position
            if (this.dropdownAppendToBody && this.menuEl) {
            }
            // todo: $animate open<->close transitions, as soon as ng2Animate will be ready
            if (this.isOpen) {
                if (this.dropdownMenuTemplateUrl) {
                }
                this.focusToggleElement();
                dropdown_service_1.dropdownService.open(this);
            }
            else {
                if (this.dropdownMenuTemplateUrl) {
                }
                dropdown_service_1.dropdownService.close(this);
                this.selectedOption = null;
            }
            this.onToggle.next(this.isOpen);
            // todo: implement call to setIsOpen if set and function
        },
        enumerable: true,
        configurable: true
    });
    Dropdown.prototype.focusDropdownEntry = function (keyCode) {
        // If append to body is used.
        var hostEl = this.menuEl ?
            this.menuEl.nativeElement :
            this.el.nativeElement.getElementsByTagName('ul')[0];
        if (!hostEl) {
            // todo: throw exception?
            return;
        }
        var elems = hostEl.getElementsByTagName('a');
        if (!elems || !elems.length) {
            // todo: throw exception?
            return;
        }
        // todo: use parseInt to detect isNumber?
        // todo: or implement selectedOption as a get\set pair with parseInt on set
        switch (keyCode) {
            case (40):
                if (typeof this.selectedOption !== 'number') {
                    this.selectedOption = 0;
                    break;
                }
                if (this.selectedOption === elems.length - 1) {
                    break;
                }
                this.selectedOption++;
                break;
            case (38):
                if (typeof this.selectedOption !== 'number') {
                    return;
                }
                if (this.selectedOption === 0) {
                    // todo: return?
                    break;
                }
                this.selectedOption--;
                break;
        }
        elems[this.selectedOption].focus();
    };
    Dropdown.prototype.focusToggleElement = function () {
        if (this.toggleEl) {
            this.toggleEl.nativeElement.focus();
        }
    };
    Dropdown = __decorate([
        angular2_1.Directive({
            selector: '[dropdown]',
            properties: ['isOpen', 'autoClose', 'keyboardNav', 'dropdownAppendToBody'],
            events: ['onToggle'],
            host: {
                '[class.dropdown]': 'true',
                '[class.open]': 'isOpen'
            }
        }), 
        __metadata('design:paramtypes', [angular2_1.ElementRef])
    ], Dropdown);
    return Dropdown;
})();
exports.Dropdown = Dropdown;
//# sourceMappingURL=dropdown.js.map